<script lang="ts" setup>
import { ref } from 'vue';

import NavigationDropdown from './NavigationDropdown.vue';
import NavigationButton from './NavigationButton.vue';
import { Gitlab, Search } from 'slippers-ui/icons';
import type { MainNavigation } from '@/types/navigation';

// Define Props
const props = defineProps<{
  data: MainNavigation;
  freeTrialLink?: string;
  hideSalesButton?: boolean;
  freeTrialVariant?: string;
}>();

// refs
const showDropdown = ref(false);
const focusedElementIndex = ref<number | null>(null);
const isSearchOpen = ref(false);

// methods

const onKeypressEnter = (currentIndex: number) => {
  if (currentIndex === focusedElementIndex.value || focusedElementIndex.value === null) {
    showDropdown.value = !showDropdown.value;
  } else {
    showDropdown.value = true;
  }
  focusedElementIndex.value = currentIndex;
};
const toggleSearch = () => {
  isSearchOpen.value = !isSearchOpen.value;
};
</script>

<template>
  <div>
    <NavigationSearch v-if="isSearchOpen" v-bind="props.data.search" @close="toggleSearch" />
    <div ref="navigation" class="be-nav-navigation">
      <div class="be-nav-navigation-bottom">
        <div class="navigation-bottom-left navigation-bottom-left--no-search">
          <SlpButton
            class="slp-mr-8"
            variant="icon"
            :href="props.data.logo.config.href"
            data-nav="logo"
            aria-label="Home"
            name="Home"
            tabindex="0"
            :data-ga-name="props.data.logo.config.dataGaName"
            :data-ga-location="props.data.logo.config.dataGaLocation"
          >
            <SlpIcon :icon="Gitlab" size="lg" aria-id="tanukiHomeDesktop" />
          </SlpButton>
          <ul>
            <li
              v-for="(navItem, index) in props.data.items"
              :key="navItem.text"
              class="navigation-item"
              @keypress.enter="onKeypressEnter(index)"
            >
              <NavigationDropdown :item-data="navItem" :show-dropdown="showDropdown && focusedElementIndex === index" />
            </li>
          </ul>
        </div>
        <div class="navigation-bottom-right">
          <SlpButton
            variant="icon"
            aria-label="Search"
            data-nav="site search"
            class="navigation__search slp-mr-24"
            @click="toggleSearch()"
          >
            <SlpIcon :icon="Search" size="sm" />
          </SlpButton>
          <SlpButton
            v-if="!hideSalesButton"
            :href="data.sales.config.href"
            variant="secondary"
            class="slp-mr-24"
            :data-ga-name="props.data.sales.config.dataGaName"
            :data-ga-location="props.data.sales.config.dataGaLocation"
            :name="data.sales.text"
          >
            {{ data.sales.text }}
          </SlpButton>
          <NavigationButton
            :name="props.data.freeTrial.text"
            :free-trial-variant="freeTrialVariant"
            :href="freeTrialLink"
            :data-ga-name="props.data.freeTrial.config.dataGaName"
            :data-ga-location="props.data.freeTrial.config.dataGaLocation"
          >
            {{ data.freeTrial.text }}
          </NavigationButton>
          <!-- Sign In -->
          <NavigationDropdown
            :item-data="data.login"
            :show-dropdown="showDropdown && focusedElementIndex === 'login'"
            class="slp-ml-24"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
$popover-width: 170px;

.be-nav-navigation {
  background-color: white;
  padding: $spacing-4 $spacing-24 $spacing-16 $spacing-24;
  backdrop-filter: blur(16px);
  -webkit-backdrop-filter: blur(16px);

  *,
  ::before,
  ::after {
    box-sizing: border-box;
  }

  &-desktop {
    overflow-x: clip;
  }

  @media screen and (min-width: $breakpoint-lg) and (max-width: $breakpoint-xl) {
    padding: $spacing-4 $spacing-24 $spacing-16 $spacing-24;
    display: flex;
    justify-content: center;
  }

  &__login-popover {
    padding: 0 $spacing-24;
    display: flex;
    flex-direction: column;
    min-width: 240px;
  }

  &__link {
    color: $color-text-link-100;

    &:hover {
      text-decoration: underline;
    }

    &:last-of-type {
      padding-bottom: 0;
    }
  }

  &__search {
    @media screen and (min-width: $breakpoint-lg) and (max-width: $breakpoint-xl) {
      margin-right: 0;
    }
    svg {
      color: $color-surface-500;
      transition: all 0.3s ease-in-out;

      &:hover {
        color: $color-surface-600;
      }
    }
  }
}

.be-nav-navigation-bottom {
  display: flex;
  justify-content: space-between;
  align-items: center;
  padding-top: $spacing-16;
  width: 100%;

  &.centered {
    justify-content: center;
  }

  &__cta {
    &--accent {
      background-color: $color-accent-300 !important;
      color: $color-primary-300 !important;
      border-color: $color-accent-300 !important;

      &:hover {
        background-color: $color-primary-300 !important;
        color: $color-accent-300 !important;
      }
    }

    &--steel {
      background: linear-gradient(93.83deg, rgba(0, 0, 0, 1) 7.27%, rgba(0, 0, 0, 1) 105.33%) !important;
      position: relative;
      overflow: hidden;

      &:after {
        content: '';
        position: absolute;
        top: 0;
        left: -200%;
        width: 200%;
        height: 100%;
        transform: skewX(-20deg);
        background-image: linear-gradient(to right, transparent, rgba(255, 255, 255, 0.5), transparent);
      }

      &:hover {
        background-color: $color-primary-300 !important;
        color: $color-primary-300 !important;
      }

      &:hover:after {
        animation: shine 0.8s ease-in-out;
      }
    }
  }

  .navigation-bottom-left {
    display: flex;
    align-items: center;
    color: $color-text-200 !important;

    ul {
      white-space: nowrap;
    }
    &--no-search {
      /// temp class until search is reinstated
      margin-right: 40px;
    }
  }

  .navigation-item {
    display: inline-block;

    &:not(:last-child) {
      margin-right: $spacing-16;
      @media screen and (min-width: $breakpoint-lg) and (max-width: $breakpoint-xl) {
        margin-right: $spacing-8;
      }
    }

    &_button {
      position: relative;
      color: $color-text-200;
      transition: all 0.1s ease-in-out;

      &:hover {
        color: $color-text-300;
      }

      &--active {
        color: $color-text-300;
      }
    }
  }

  .navigation-bottom-right {
    display: flex;
    align-items: center;

    .slp-btn {
      &:not(:first-child) {
        @media screen and (min-width: $breakpoint-lg) and (max-width: $breakpoint-xl) {
          margin-right: $spacing-8;
        }
      }
    }
  }
}

.v-popper {
  &__arrow-container {
    display: none !important;
  }

  &__popper {
    outline: none !important;
  }
}

@keyframes shine {
  100% {
    left: 200%;
  }
}
</style>
